poj 1414 DP

网上搜的分类是DP,但是遍历就行了。。。。只不过有点麻烦。。。。。

AC代码如下:

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <queue>
using namespace std;

#define MAX 0x3f3f3f3f

struct Point{
	int x, y;
};

struct Group{
	int id;
	int size;
	Point p[55];
	int cnt;
};

int num[11][11], N, C, groupnum;
Group group[55];
bool mark[11][11];
int hashs[11][11];
int moves[][2] = { { 0, 1 }, { 0, -1 }, { -1, -1 }, { -1, 0 }, { 1, 0 }, { 1, 1 } };

void DFS( int x, int y, int groupid, queue<Point> &q ){
	if( x > N || x < 1 || y > N || y < 1 || y > x || mark[x][y] ){
		return;
	}
	if( num[x][y] != group[groupid].id ){
		return;
	}
	Point pp;
	pp.x = x;
	pp.y = y;
	q.push( pp );
	mark[pp.x][pp.y] = true;
	for( int i = 0; i < 6; i++ ){
		DFS( x + moves[i][0], y + moves[i][1], groupid, q );
	}
}

int main(){
	
	while( cin >> N >> C && !( N == 0 && C == 0 ) ){
		
		groupnum = 0;
		
		//读数据
		for( int i = 1; i <= N; i++ ){
			for( int j = 1; j <= i; j++ ){
				scanf( "%d", &num[i][j] );
			}
		}
		
		//分组
		memset( mark, false, sizeof( mark ) );
		for( int i = 1; i <= N; i++ ){
			for( int j = 1; j <= i; j++ ){
				if( num[i][j] != 0 && !mark[i][j] ){
					
					group[groupnum].id = num[i][j];
					int cnt = 0;
					
					queue<Point> q;
					while( !q.empty() ){
						q.pop();
					}
					DFS( i, j, groupnum, q );//深搜搜出相连的为一组
					
					group[groupnum].size = q.size();

					//找出与该组相连的空位
					bool tempmark[130];
					memset( tempmark, false, sizeof( tempmark ) );
					while( !q.empty() ){
						Point p = q.front();
						q.pop();
						hashs[p.x][p.y] = groupnum;
						for( int k = 0; k < 6; k++ ){
							Point temppoint = p;
							temppoint.x += moves[k][0];
							temppoint.y += moves[k][1];
							if( temppoint.x > N || temppoint.x < 1 || temppoint.y > N || temppoint.y < 1 || temppoint.y > temppoint.x ){
								continue;
							}
							if( num[temppoint.x][temppoint.y] != 0 || tempmark[temppoint.x*11+temppoint.y] ){
								continue;
							}
							group[groupnum].p[cnt].x = temppoint.x;
							group[groupnum].p[cnt++].y = temppoint.y;
							tempmark[temppoint.x*11+temppoint.y] = true;
						}
					}

					group[groupnum++].cnt = cnt;
				}
			}

		}

		//遍历
		int ans = -MAX;
		for( int i = 1; i <= N; i++ ){
			for( int j = 1; j <= i; j++ ){
				
				if( num[i][j] != 0 ){
					continue;
				}
				
				int sub = 1, add = 0;
				//计算能消的
				for( int k = 0; k < groupnum; k++ ){
					if( group[k].cnt > 1 ){
						continue;
					}else{
						if( group[k].p[0].x == i && group[k].p[0].y == j ){
							if( group[k].id == C ){
								sub += group[k].size;
							}else{
								add += group[k].size;
							}
						}
					}
				}

				//计算自己要被消的数量
				int flag = 1;
				for( int k = 0; k < 6; k++ ){
					int tempx = i, tempy = j;
					tempx += moves[k][0];
					tempy += moves[k][1];
					if( tempx > N || tempx < 1 || tempy > N || tempy < 1 || tempy > tempx ){
						continue;
					}
					if( num[tempx][tempy] == 0 ){
						flag = 0;
						break;
					}
					if( num[tempx][tempy] == C && group[hashs[tempx][tempy]].cnt > 1 ){
						flag = 0;
						break;
					}
				}
				if( !flag ){
					sub = 0;
				}
				
				//取最大
				ans = max( ans, add - sub );
			}
		}

		cout << ans << endl;
	}

	return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值